starfield=constructObject()

function starfield:load()
  tile={}
  for i=1,21 do tile[i]=newPaddedImage("/img/tiles/"..i..".png") end
  self.w,self.h=tile[1].w,tile[1].h
end

-- create a random row of stars
local function newStarRow()
  local row={}
  for i=1,20 do
    local starcheck=math.random(6)+math.random(6) -- is there a star system here?
    if starcheck<10 then row[i]=1 -- no system present
    else -- start system indicated...
      local systemsize=math.random(6)+math.random(6) -- how big is it?
      if systemsize<=9 then row[i]=math.random(2,5) -- unary
      elseif systemsize==10 then row[i]=math.random(6,15) -- binary
      else row[i]=math.random(16,21) end -- trinary
    end
  end
  return row
end

function starfield:init()
  self.row={}
  for i=1,16 do self.row[i]=newStarRow() end
  self.rowoffset=0
  self.speed=100
end

function starfield:draw()
  local x,y=0,love.graphics.getHeight()-self.h+self.rowoffset
  for i=1,16 do
    for j=1,20 do love.graphics.draw(tile[self.row[i][j]].image,x,y) x=x+self.w end
    x,y=0,y-self.h
  end
end

function starfield:update(dt)
  --self.rowoffset=self.rowoffset+((self.speed+((player.level-1)*5))*dt)
  self.rowoffset=self.rowoffset+((self.speed+((player.level-1)*10))*dt)
  if self.rowoffset>=self.h then
    self.rowoffset=0
    table.remove(self.row,1)
    table.insert(self.row,newStarRow())
  end
end