enemy=constructObject()

function enemy:load()
  self.ship={
    newPaddedImage('/img/ships/enemy1.png'),
    newPaddedImage('/img/ships/enemy2.png'),
    newPaddedImage('/img/ships/enemy3.png'),
    newPaddedImage('/img/ships/enemy4.png'),
    newPaddedImage('/img/ships/enemy5.png')
  }
end

function enemy:init()
  self.speed={50,40,60,30,50}
  self.htk={1,3,5,7,9} -- hits to kill
  self.points={
    {10},
    {10,15,20},
    {10,15,20,25,30},
    {10,15,20,25,30,35,40},
    {10,15,20,25,30,35,40,45,50}
  }
  self.ships={}
  self.firefuselen={5,5,5,5,5}
  self.firefusespeed={20,40,30,50,80}
  self.battlevalue=0
end

function enemy:add(shiptype,x,y)
  table.insert(self.ships,{})
  local this=self.ships[#self.ships]
  this.image=self.ship[shiptype].image
  if not x and not y then
    this.x=math.random(self.ship[shiptype].w+(player.w/2),love.graphics.getWidth()-self.ship[shiptype].w-(player.w/2))
    this.y=0-self.ship[shiptype].h
  else this.x,this.y=x,y end
  this.w=self.ship[shiptype].w
  this.h=self.ship[shiptype].h
  this.speed=self.speed[shiptype]
  this.htk=self.htk[shiptype]
  this.points=self.points[shiptype]
  this.dmg=0 -- amount of damage sustained
  this.phits=0 -- amount of damage caused by the player
  this.shiptype=shiptype
  this.firefuse=0
  this.firefuselen=self.firefuselen[shiptype]
  this.firefusespeed=self.firefusespeed[shiptype]
  if shiptype==1 then self.battlevalue=self.battlevalue+2 end
  if shiptype==2 then self.battlevalue=self.battlevalue+5 end
  if shiptype==3 then self.battlevalue=self.battlevalue+9 end
  if shiptype==4 then self.battlevalue=self.battlevalue+12 end
  if shiptype==5 then self.battlevalue=self.battlevalue+27 end
end

function enemy:applyDamage(ship,amount,creditplayer)
  local this=self.ships[ship]
  local credit=0
  if creditplayer then
    for i=1,this.phits+amount do
      if i>this.phits then
        if this.points[i] then credit=credit+this.points[i] end
      end
    end
    this.phits=this.phits+amount
    player.score=player.score+credit
  end
  this.dmg=this.dmg+amount
  if this.dmg>=this.htk then
    local mx,my=getMidpoint(this.x,this.y,this.w,this.h)
    local strength=amount
    if strength>this.htk then strength=this.htk end
    local radius=(this.w+this.h)/2
    shockwave:add(mx,my,radius,this.speed,strength,creditplayer)
    explosion:add(mx,my,this.speed,1)
    if math.random(6)==1 then
      for i=1,math.random(2) do embers:add(this.x,this.y,this.w,this.h,this.speed,1) end
    end
    player.kills=player.kills+1
    if this.shiptype==1 then self.battlevalue=self.battlevalue-2 end
    if this.shiptype==2 then self.battlevalue=self.battlevalue-5 end
    if this.shiptype==3 then self.battlevalue=self.battlevalue-9 end
    if this.shiptype==4 then self.battlevalue=self.battlevalue-12 end
    if this.shiptype==5 then self.battlevalue=self.battlevalue-27 end
    local dropchance=this.shiptype*25
    if math.random(100)<=dropchance then
      local pwrtype={'shields'}
      if player.shields<5 then table.insert(pwrtype,'shields') end
      if player.level>=3 then
        if math.random(6)<=2 then table.insert(pwrtype,'firerate') end
        if this.shiptype>1 then table.insert(pwrtype,'firerate') end
      end
      if player.level>=6 then
        if math.random(6)==1 then table.insert(pwrtype,'cannon') end
        if this.shiptype>2 then table.insert(pwrtype,'cannon') end
      end
      powerup:add(mx,my,pwrtype[math.random(#pwrtype)])
    end
    table.remove(self.ships,ship)
    return true
  end
  return false
end

function enemy:draw()
  for i=1,#self.ships do
    love.graphics.draw(self.ships[i].image,math.floor(self.ships[i].x),math.floor(self.ships[i].y))
  end
end

function enemy:move(dt)
  i=1
  while i<=#self.ships do
    local this=self.ships[i]
    j=1
    local dodged=false
    while j<=#playerlaser.fires do
      local mx,my=getMidpoint(this.x,this.y,this.w,this.h)
      local fx=playerlaser.fires[j][1]+(playerlaser.w/2)
      local fy=playerlaser.fires[j][2]+17
      if getDistance(mx,my,fx,fy)<this.w*2 then
        if not this.dir then
          this.dir=1
          if math.random(2)==1 then this.dir=-1 end
        end
        this.x=this.x+(((this.speed*1.5)*dt)*this.dir)
        j=#playerlaser.fires
        dodged=true
      end
      j=j+1
    end
    if dodged then this.y=this.y+(this.speed*dt) end
    if not dodged then this.dir=nil end

    if this.movepattern=='meander' then
      local movecheck=math.random(6)
      if this.movebias==nil then this.movebias=movecheck
      else
        movecheck=this.movebias
        if math.random(100)==1 then this.movebias=nil end
      end
      if movecheck<3 then
        this.x=this.x-(this.speed*dt)
        if this.x<player.w/2 then this.x=player.w/2 end
      end
      if movecheck>4 then
        this.x=this.x+(this.speed*dt)
        if this.x+this.w+(player.w/2)>love.graphics.getWidth() then
          this.x=love.graphics.getWidth()-this.w-(player.w/2)
        end
      end
      this.y=this.y+(this.speed*dt)
    end
    if this.movepattern=='diagL' then
      this.x=this.x-(this.speed*dt)
      this.y=this.y+((this.speed*3)*dt)
    end
    if this.movepattern=='diagR' then
      this.x=this.x+(this.speed*dt)
      this.y=this.y+((this.speed*3)*dt)
    end
    if this.movepattern=='zigzag' then
      if this.x<=love.graphics.getWidth()/2 then this.x=this.x+(this.speed*dt)
      else this.x=this.x-(this.speed*dt) end
      this.y=this.y+((this.speed*3)*dt)
    end
    if this.movepattern=='bumrush' then
      this.y=this.y+((this.speed*4)*dt)
    end
    if this.movepattern=='kamikaze' then
      local mx,my=getMidpoint(this.x,this.y,this.w,this.h)
      local pmx,pmy=getMidpoint(player.x,player.y,player.w,player.h)
      if mx<pmx then this.x=this.x+((this.speed*1.5)*dt) end
      if mx>pmx then this.x=this.x-((this.speed*1.5)*dt) end
      this.y=this.y+((this.speed*3)*dt)
    end
    if this.y>love.graphics.getHeight() or this.x>love.graphics.getWidth() or this.x+this.h<0 then
      if this.shiptype==1 then self.battlevalue=self.battlevalue-2 end
      if this.shiptype==2 then self.battlevalue=self.battlevalue-5 end
      if this.shiptype==3 then self.battlevalue=self.battlevalue-9 end
      if this.shiptype==4 then self.battlevalue=self.battlevalue-12 end
      if this.shiptype==5 then self.battlevalue=self.battlevalue-27 end
      table.remove(self.ships,i) i=i-1
    end
    i=i+1
  end
end

function enemy:checkRamming()
  i=1
  while i<=#self.ships do
    local this=self.ships[i]
    local x,y=this.x,this.y
    local hasrammed=false
    if y>player.y-this.h and y<player.y+player.h then -- top and bottom of player ship
      if x>player.x-this.w and x<player.x+player.w then -- outermost edges of player ship
        if x>player.x+19-this.h and x<player.x+player.w-19 then hasrammed=true end -- main body of player ship
        if y+this.h>player.y+17 then hasrammed=true end -- top of the wing
      end
      if hasrammed then
        local mx,my=getMidpoint(this.x,this.y,this.w,this.h)
        explosion:add(mx,my,this.speed,1)
        table.remove(self.ships,i)
        i=i-1
        player:kill()
      end
    end
    i=i+1
  end
end

function enemy:runFires(dt)
  i=1
  while i<=#self.ships do
    local this=self.ships[i]
    if this.firefuse>0 then
      this.firefuse=this.firefuse-(this.firefusespeed*dt)
      if this.firefuse<0 then this.firefuse=0 end
    else
      local mx,my=getMidpoint(this.x,this.y,this.w,this.h)
      local firechance=1 -- small chance to seed unoccupied space with fire obstacles
      if mx>player.x and mx<player.x+player.w then firechance=40 end -- LOS with player's wings (at least)
      if mx>player.x+19 and mx<player.x+player.w-19 then firechance=80 end -- LOS with player's main body
      if mx+(this.w/2)>player.x and mx-(this.w/2)<player.x+player.w then -- add some width to the LOS checking
        if firechance==1 then firechance=60
        else firechance=firechance*1.5 end
      end
      if math.random(400)<=firechance then
        if this.shiptype==1 then enemylaser:addfire(mx,my) end -- laser fire
        if this.shiptype==2 then starfire:addfire(mx,my) end -- starfire
        if this.shiptype==3 then -- mk II laser
          bluelaser:addfire(this.x+10,this.y+37)
          bluelaser:addfire(this.x+82,this.y+37)
        end
        if this.shiptype==4 then energywave:addfire(mx,my) end -- energy wave
        if this.shiptype==5 then -- mk II starfire (fudged a bit)
          for i=1,3 do starfire:playsound() end
          local sfwo,sfho=starfire.w/2,starfire.h/2
          for i=1,2 do
          table.insert(starfire.fires,{mx-sfwo,this.y+this.h-sfho,-1})
          table.insert(starfire.fires,{mx-sfwo,this.y+this.h-sfho,0})
          table.insert(starfire.fires,{mx-sfwo,this.y+this.h-sfho,1})
          table.insert(starfire.fires,{this.x+11-sfwo,this.y+79-sfho,1})
          table.insert(starfire.fires,{this.x+22-sfwo,this.y+76-sfho,0})
          table.insert(starfire.fires,{this.x+33-sfwo,this.y+73-sfho,-1})
          table.insert(starfire.fires,{this.x+94-sfwo,this.y+73-sfho,1})
          table.insert(starfire.fires,{this.x+105-sfwo,this.y+76-sfho,0})
          table.insert(starfire.fires,{this.x+116-sfwo,this.y+79-sfho,-1})
          end
        end
        this.firefuse=this.firefuselen
      end
    end
  i=i+1
  end
end

function enemy:reinforce()
  --if #self.ships>player.level*5 then return end -- prevent too many ships on screen at once (a problem at higher levels)
  if self.battlevalue>=player.battlevalue then return end -- good for now
  if math.random(100)>player.level and self.battlevalue>player.battlevalue/2 then return end -- player gets some breathing room
  local weak=1
  local middling=2
  local tough=3
  if player.level>=7 then weak=2 middling=2 tough=3 end
  if player.level>=8 then weak=2 middling=3 tough=3 end
  if player.level>=9 then weak=2 middling=3 tough=4 end
  if player.level>=10 then weak=3 middling=3 tough=4 end
  if player.level>=11 then weak=3 middling=4 tough=4 end
  if player.level>=12 then weak=3 middling=4 tough=5 end
  if player.level>=13 then weak=4 middling=4 tough=5 end
  if player.level>=14 then weak=4 middling=5 tough=5 end
  local check=math.random(6)+math.random(6)+math.random(6) -- approximate a bell curve
  local rank=0
  if check==3 then rank=1 end
  if check==4 or check==5 then rank=2 end
  if check>=6 and check<=8 then rank=3 end
  if check>=9 and check<=12 then rank=4 end
  if check>=13 and check<=15 then rank=5 end
  if check==16 or check==17 then rank=6 end
  if check==18 then rank=7 end
  rank=rank+(player.level-1)--+math.floor((player.battlevalue-12)/2)
  local movecheck=math.random(145)-((7-rank)*5)
  local movetype='meander'
  if movecheck>50 then movetype='diagL' end
  if movecheck>75 then movetype='diagR' end
  if movecheck>100 then movetype='zigzag' end
  if movecheck>120 then movetype='bumrush' end
  if movecheck>135 then movetype='kamikaze' end
  
  --rank=3 -- forced for testing
  
  local minx=player.w/2
  while rank>0 do
    if rank==1 then self:add(weak) rank=rank-1 self.ships[#self.ships].movepattern=movetype end
    if rank==2 then
      self:add(weak)
      self.ships[#self.ships].movepattern=movetype
      local this=self.ships[#self.ships]
      local maxx=(love.graphics.getWidth()-(player.w/2)-this.w)
      local hpos=this.w*2
      if this.x-hpos<minx then hpos=math.random(0,1)*hpos
      elseif this.x+hpos>maxx then hpos=math.random(-1,0)*hpos
      else hpos=math.random(-1,1)*hpos end
      local vpos=(this.h*2)*math.random(-1,0)
      if hpos==0 then vpos=-1*(this.h*2) end
      self:add(weak,this.x+hpos,this.y+vpos)
      self.ships[#self.ships].movepattern=movetype
      rank=rank-2
    end
    if rank==3 then
      local flag='A'
      if player.level>=3 then
        if math.random(2)==1 then flag='B' end
      end
      if flag=='A' then
        self:add(weak)
        self.ships[#self.ships].movepattern=movetype
        local this=self.ships[#self.ships]
        local maxx=(love.graphics.getWidth()-(player.w/2)-this.w)
        local hpos=this.w*4
        local formations={}
        if this.x-hpos>=minx and this.x+hpos<=maxx then formations={1,2,3,4} end
        if this.x-hpos>=minx and this.x+hpos>maxx and this.x+(hpos/2)<=maxx then formations={1,2,4} end
        if this.x+hpos<=maxx and this.x-hpos<minx and this.x-(hpos/2)>=minx then formations={1,3,4} end
        if formations[1]==nil and this.x-(hpos/2)>=minx and this.x+(hpos/2)<=maxx then formations={1,4} end
        if formations[1]==nil then formations={4} end
        local formation=formations[math.random(#formations)]
        if formation==1 then
          if math.random(2)==1 then
            self:add(weak,this.x-(hpos/2),this.y)
            self.ships[#self.ships].movepattern=movetype
            self:add(weak,this.x+(hpos/2),this.y)
            self.ships[#self.ships].movepattern=movetype
          else
            self:add(weak,this.x-(hpos/2),this.y-(hpos/2))
            self.ships[#self.ships].movepattern=movetype
            self:add(weak,this.x+(hpos/2),this.y-(hpos/2))
            self.ships[#self.ships].movepattern=movetype
          end
        end
        if formation==2 then
          self:add(weak,this.x-(hpos/2),this.y-(this.h*2))
          self.ships[#self.ships].movepattern=movetype
          self:add(weak,this.x-hpos,this.y-(this.h*4))
          self.ships[#self.ships].movepattern=movetype
        end
        if formation==3 then
          self:add(weak,this.x+(hpos/2),this.y-(this.h*2))
          self.ships[#self.ships].movepattern=movetype
          self:add(weak,this.x+hpos,this.y-(this.h*4))
          self.ships[#self.ships].movepattern=movetype
        end
        if formation==4 then
          self:add(weak,this.x,this.y-(this.h*2))
          self.ships[#self.ships].movepattern=movetype
          self:add(weak,this.x,this.y-(this.h*4))
          self.ships[#self.ships].movepattern=movetype
        end
      else self:add(middling) self.ships[#self.ships].movepattern=movetype end
      rank=rank-3
    end
    
    
    if rank==4 then
      local flag='A'
      if player.level>=3 then
        if math.random(2)==1 then flag='B' end
      end
      if flag=='A' then
        for i=1,4 do self:add(weak) self.ships[#self.ships].movepattern=movetype end -- quick & dirty test add
      else
        self:add(middling)
        self.ships[#self.ships].movepattern=movetype
        self:add(weak)
        self.ships[#self.ships].movepattern=movetype
      end -- ditto
      rank=rank-4
    end
    if rank==5 then
      local flag='A'
      if player.level>=3 then
        if math.random(2)==1 then flag='B' end
      end
      if player.level>=6 then
        local flags={'A','B','C'}
        flag=flags[math.random(#flags)]
      end
      if flag=='A' then
        for i=1,5 do self:add(weak) self.ships[#self.ships].movepattern=movetype end -- quick & dirty test add
      elseif flag=='B' then
        if math.random(2)==1 then
          for i=1,2 do self:add(middling) self.ships[#self.ships].movepattern=movetype end -- Q&D testing
        else
          self:add(middling)
          self.ships[#self.ships].movepattern=movetype
          self:add(weak)
          self.ships[#self.ships].movepattern=movetype
          self:add(weak)
          self.ships[#self.ships].movepattern=movetype
        end -- Q&D testing
      else self:add(tough) self.ships[#self.ships].movepattern=movetype end -- Q&D testing
      rank=rank-5
    end
    if rank==6 then
      local flag='A'
      if player.level>=3 then
        if math.random(2)==1 then flag='B' end
      end
      if player.level>=6 then
        local flags={'A','B','C'}
        flag=flags[math.random(#flags)]
      end
      if flag=='A' then
        for i=1,6 do self:add(weak) self.ships[#self.ships].movepattern=movetype end -- quick & dirty test add
      elseif flag=='B' then
        if math.random(2)==1 then
          self:add(middling)
          self.ships[#self.ships].movepattern=movetype
          for i=1,3 do self:add(weak) self.ships[#self.ships].movepattern=movetype end -- Q&D testing
        else
          self:add(middling)
          self.ships[#self.ships].movepattern=movetype
          for i=1,4 do self:add(weak) self.ships[#self.ships].movepattern=movetype end
        end -- Q&D testing
      else
        self:add(tough)
        self.ships[#self.ships].movepattern=movetype
        self:add(middling)
        self.ships[#self.ships].movepattern=movetype
      end -- Q&D testing
      rank=rank-6
    end
    if rank>=7 then
      local flag='A'
      if player.level>=3 then
        if math.random(2)==1 then flag='B' end
      end
      if player.level>=6 then
        local flags={'A','B','C'}
        flag=flags[math.random(#flags)]
      end
      if flag=='A' then
        for i=1,7 do self:add(weak) self.ships[#self.ships].movepattern=movetype end -- quick & dirty test add
      elseif flag=='B' then
        if math.random(2)==1 then
          for i=1,3 do self:add(middling) self.ships[#self.ships].movepattern=movetype end -- Q&D testing
        else
          self:add(middling)
          self.ships[#self.ships].movepattern=movetype
          for i=1,5 do self:add(weak) self.ships[#self.ships].movepattern=movetype end
        end -- Q&D testing
      else
        local check=math.random(3)
        if check==1 then
          self:add(tough)
          self.ships[#self.ships].movepattern=movetype
          self:add(tough)
          self.ships[#self.ships].movepattern=movetype
        end -- Q&D testing
        if check==2 then
          self:add(tough)
          self.ships[#self.ships].movepattern=movetype
          self:add(weak)
          self.ships[#self.ships].movepattern=movetype
          self:add(weak)
          self.ships[#self.ships].movepattern=movetype
        end -- Q&D testing
        if check==3 then
          self:add(tough)
          self.ships[#self.ships].movepattern=movetype
          self:add(middling)
          self.ships[#self.ships].movepattern=movetype
        end
      end -- Q&D testing
      rank=rank-7
      --if #self.ships>player.level*3 and math.random(100)<=50+player.level then return end
      if #self.ships>player.level*5 and math.random(100)<=50 then return end
    end
  end
end

function enemy:update(dt)
  self:move(dt)
  if not player.isdead and not player.isreviving then
    self:checkRamming() -- see if the enemy has rammed into the player
    self:runFires(dt) -- update & check for enemy fires
    self:reinforce() -- see if we need more enemies
  end
end