player=constructObject()

function player:load()
  ship1=newPaddedImage('/img/ships/player1.png')
  ship2=newPaddedImage('/img/ships/player2.png')
  self.image=ship1.image
  self.w,self.h=ship1.w,ship1.h
end

function player:init()
  self.x=love.graphics.getWidth()/2-(self.w/2)
  self.y=love.graphics.getHeight()-(self.h*2.5)
  self.speed=250
  self.shields=10
  self.lives=3
  self.isdead=false
  self.isreviving=false
  self.revivefuse=0
  self.revivefuselen=30
  self.revivefusespeed=15
  self.score=0
  self.neededscore=100
  self.kills=0
  self.level=1
  self.battlevalue=12
  self.firerate=0
  self.hascannon=false
end

function player:damage(amount)
  self.shields=self.shields-amount
  if self.shields<=0 and (not self.isdead or not self.isreviving) then player:kill() end
end

function player:kill()
  local mx,my=getMidpoint(self.x,self.y,self.w,self.h)
    local radius=self.w*1.5
    shockwave.forcedDamage=true
    explosion:add(mx,my,0,0)
    for i=1,10 do
      explosion:add(math.random(self.x-(self.w/2),self.x+(self.w*1.5)),
                           math.random(self.y-(self.h/2),self.y+(self.h*1.5)),0,0)
    end
    shockwave:add(mx,my,radius,0,10,false)
    self.lives=self.lives-1
    if self.lives<0 then self.lives=0 end
    self.isdead=true
    if self.firerate>0 then
      local adjust=math.floor(self.firerate/2)
      self.firerate=self.firerate-adjust
      self.battlevalue=self.battlevalue-adjust
    end
    if self.hascannon==true then
      player.hascannon=false
      player.image=ship1.image
      player.battlevalue=player.battlevalue-6
    end
    if self.lives>0 then self.isreviving=true self.revivefuse=self.revivefuselen
    else bgmusic:stop() end
--[[
  else
    bgmusic:stop()
    -- check for new high score
    local rung=21
    for i=1,20,2 do
      if rung==21 then
        if highscoredata[i]==nil then rung=i
        elseif player.score>highscoredata[i+1] then rung=i
        elseif player.score==highscoredata[i+1] then rung=i+2 end
      end
    end
    if rung<21 then gamestate="newhighscore" highscorerung=rung
    else gamestate="gameover" end
  end
]]
end

function player:revive()
  player.shields=10
  player.isreviving=false
  player.isdead=false
end

function player:draw()
  if not self.isdead or (self.isdead and self.isreviving) then
    if self.isreviving then love.graphics.setColor(255,255,255,64) end
    love.graphics.draw(self.image,math.floor(self.x),math.floor(self.y))
    if self.isreviving then love.graphics.setColor(255,255,255,255) end
  end
end

function player:updateLevel()
  while self.score>=self.neededscore do
    self.level=self.level+1
    self.battlevalue=self.battlevalue+5
    alertsound:play()
    self.neededscore=self.neededscore+(self.level*100)
    if self.level>=3 then self.neededscore=self.neededscore+((self.level-2)*450) end
    if self.level>=6 then self.neededscore=self.neededscore+((self.level-5)*1000) end
    if self.level>=9 then self.neededscore=self.neededscore+((self.level-8)*1750) end
    if self.level>=12 then self.neededscore=self.neededscore+((self.level-11)*2700) end
  end
end

function player:update(dt)
  if love.keyboard.isDown("left") or love.keyboard.isDown("a") then
    self.x=self.x-(self.speed*dt)
    if self.x<0 then self.x=0 end
  end
  if love.keyboard.isDown("right") or love.keyboard.isDown("d") then
    self.x=self.x+(self.speed*dt)
    if self.x+self.w>love.graphics.getWidth() then self.x=love.graphics.getWidth()-self.w end
  end
  if love.keyboard.isDown("up") or love.keyboard.isDown("w") then
    self.y=self.y-(self.speed*dt)
    if self.y<love.graphics.getHeight()*0.75 then self.y=love.graphics.getHeight()*0.75 end
  end
  if love.keyboard.isDown("down") or love.keyboard.isDown("s") then
    self.y=self.y+(self.speed*dt)
    if self.y>love.graphics.getHeight()-self.h then self.y=love.graphics.getHeight()-self.h end
  end
  if not self.isdead and not self.isreviving then
    if love.keyboard.isDown(" ") then
      playerlaser:addfire(math.floor(self.x-9),math.floor(self.y-46))
      if self.hascannon then
        energycannon:addfire(math.floor(self.x+5-(energycannon.w/2)),math.floor(self.y+8-(energycannon.h/2)))
      end
    end
    while self.kills>=250 do
      status.oneupcount=1
      status.oneupblink=true
      self.lives=self.lives+1
      self.kills=self.kills-250
      if self.kills<0 then self.kills=0 end -- sometimes happens in multiple kills...
    end
    self:updateLevel()
  end
  if self.isreviving then
    self.revivefuse=self.revivefuse-(self.revivefusespeed*dt)
    if self.revivefuse<=0 then self.revivefuse=0 self:revive() end
  end
end