powerup=constructObject()

function powerup:load()
  self.shields={}
  for i=1,6 do self.shields[i]=newPaddedImage('/img/powerups/shields/'..i..'.png') end
  self.firerate={}
  for i=1,6 do self.firerate[i]=newPaddedImage('/img/powerups/firerate/'..i..'.png') end
  self.cannon={}
  for i=1,6 do self.cannon[i]=newPaddedImage('/img/powerups/cannon/'..i..'.png') end
  self.soundfile='/snd/powerup.ogg'
end

function powerup:init()
  self.data={}
  self.scale=1.25
  self.w,self.h=self.shields[1].w*self.scale,self.shields[1].h*self.scale
end

function powerup:add(x,y,pwrtype)
  table.insert(self.data,{x-(self.w/2),y-(self.h/2),pwrtype,1})
end

function powerup:draw()
  i=1
  while i<=#self.data do
    local this=self.data[i]
    local x,y=this[1],this[2]
    local frame=math.ceil(this[4])
    local image
    if this[3]=='shields' then image=self.shields[frame].image end
    if this[3]=='firerate' then image=self.firerate[frame].image end
    if this[3]=='cannon' then image=self.cannon[frame].image end
    love.graphics.draw(image,x,y,0,self.scale)
    i=i+1
  end
end

function powerup:update(dt)
  i=1
  while i<=#self.data do
    local this=self.data[i]
    local x,y=this[1],this[2]
    local pwrtype=this[3]
    local frame=this[4]
    y=y+(100*dt)
    frame=frame+(10*dt)
    if frame>6 then frame=1 end
    self.data[i]={x,y,pwrtype,frame}
    if y>love.graphics.getHeight() then
      table.remove(self.data,i)
      i=i-1
    end
    i=i+1
  end
  if not player.isdead and not player.isreviving then
    i=1
    while i<=#self.data do
      local this=self.data[i]
      local x,y=this[1],this[2]
      local pwrtype=this[3]
      local collided=false
      if y>player.y-self.h and y<player.y+player.h then -- top and bottom of player ship
        if x>player.x-self.w and x<player.x+player.w then -- outermost edges of player ship
          if x>player.x+19-self.h and x<player.x+player.w-19 then collided=true end -- main body of player ship
          if y+self.h>player.y+17 then collided=true end -- top of the wing
        end
        if collided then
          self:playsound()
          if pwrtype=='shields' then
            player.shields=player.shields+3
            if player.shields>10 then player.shields=10 player.score=player.score+1 end
          end
          if pwrtype=='firerate' then
            player.firerate=player.firerate+5
            player.battlevalue=player.battlevalue+5
            if player.firerate>20 then
              local adjust=player.firerate-20
              player.firerate=player.firerate-adjust
              player.battlevalue=player.battlevalue-adjust
              player.score=player.score+2
            end
          end
          if pwrtype=='cannon' then
            if not player.hascannon then
              player.hascannon=true player.image=ship2.image player.battlevalue=player.battlevalue+6
            else player.score=player.score+3 end
          end
          table.remove(self.data,i)
          i=i-1
        end
      end
      i=i+1
    end
  end
  self:trimsound()
  if math.random(100)<=(10-player.shields)/2 and #self.data<math.floor(#enemy.ships/10) then
    self:add(math.random(self.w/2,love.graphics.getWidth()-self.w),0,'shields')
  end
end