enemylaser=constructObject()

function enemylaser:load()
  local fire=newPaddedImage('/img/weapons/enemy/laser.png')
  self.image=fire.image
  self.w,self.h=fire.w,fire.h
  self.soundfile='/snd/enemy/laser.ogg'
end

function enemylaser:init()
  self.speed=250
  self.fires={}
  self.dmg=1
end

function enemylaser:addfire(x,y)
  self:playsound()
  table.insert(self.fires,{x-(self.w/2),y-20})
end

function enemylaser:draw()
  love.graphics.setColor(255,255,255,128)
  for i=1,#self.fires do
    love.graphics.draw(self.image,math.floor(self.fires[i][1]),math.floor(self.fires[i][2]))
  end
  love.graphics.setColor(255,255,255,255)
end

function enemylaser:update(dt)
  i=1
  while i<=#self.fires do
    local x,y=self.fires[i][1],self.fires[i][2]
    y=y+(self.speed*dt)
    if y>love.graphics.getHeight() then table.remove(self.fires,i)
    else self.fires[i]={x,y} i=i+1 end
  end
  -- collision checking
  i=1
  while i<=#self.fires do
    local hashit=false
    local this=self.fires[i]
    local x,y,w,h=this[1]+29,this[2]+18,5,26
    local hx,hy=x+2,y+(h/2)
    if y>player.y-h and y<player.y+player.h then -- top and bottom of player ship
      if x>player.x-w and x<player.x+player.w then -- outermost edges of player ship
        if x>player.x+19-h and x<player.x+player.w-19 then hashit=true end -- main body of player ship
        if y+h>player.y+17 then hashit=true hy=((player.y+17)+(player.y+player.h))/2 end -- top of the wing
      end
    end
    if hashit then
      hit:add(hx,hy,player.speed,-1)
      player:damage(self.dmg)
      table.remove(self.fires,i)
      i=i-1
    end
    i=i+1
  end
  self:trimsound()
end