energycannon=constructObject()

function energycannon:load()
  local fire=newPaddedImage('/img/weapons/player/cannon.png')
  self.image=fire.image
  self.w,self.h=fire.w,fire.h
  self.dmg=3
  --self.soundfile='/snd/player/'
end

function energycannon:init()
  self.fuse=0
  self.fuselen=10
  self.fusespeed=20
  self.speed=125
  self.fires={}
  self.dmg=3
end

function energycannon:addfire(x,y)
  if self.fuse>0 then return end
  -- also check to be sure player has it
  --self:playsound()
  table.insert(self.fires,{x,y,-1})
  table.insert(self.fires,{x+46,y,1})
  self.fuse=self.fuselen
end

function energycannon:draw()
  love.graphics.setColor(255,255,255,128)
  for i=1,#self.fires do
    love.graphics.draw(self.image,math.floor(self.fires[i][1]),math.floor(self.fires[i][2]))
  end
  love.graphics.setColor(255,255,255,255)
end

function energycannon:update(dt)
  i=1
  while i<=#self.fires do
    local x,y=self.fires[i][1],self.fires[i][2]
    y=y-(self.speed*dt)
    x=x+(((self.speed*0.6)*dt)*self.fires[i][3])
    if y<(self.h*-1) then table.remove(self.fires,i)
    else self.fires[i]={x,y,self.fires[i][3]} i=i+1 end
  end
  if self.fuse>0 then
   self.fuse=self.fuse-((self.fusespeed+player.firerate)*dt)
   if self.fuse<0 then self.fuse=0 end
  end
  -- collision checking
  i=1
  while i<=#self.fires do
    local hashit=false
    local fl,fr=self.fires[i][1]+28,self.fires[i][1]+35 -- fire left & right
    local ft,fb=self.fires[i][2]+23,self.fires[i][2]+28 -- fire top & bottom
    local ship=1
    while ship<=#enemy.ships do
      local this=enemy.ships[ship]
      local sl,sr=this.x,this.x+this.w -- ship left & right
      local st,sb=this.y,this.y+this.h -- ship top & bottom
      if (fr>=sl and fl<=sr) and (ft<=sb and fb>=st) then
        local hx=fl+2
        if hx>sr then hx=sr end
        if hx<sl then hx=sl end
        local hy=(ft+fb)/2
        if hy<st then hy=st end
        if hy>sb then hy=sb end
        local swmx,swmy=getMidpoint(this.x,this.y,this.w,this.h)
        local swspd=this.speed
        hit:add(hx,hy,this.speed,1)
        hashit=true
        local isdead=enemy:applyDamage(ship,self.dmg,true)
        if isdead then ship=ship-1 end
        --shockwave:add(swmx,swmy,48,0,1,true)
        --shockwave:add(swmx,swmy,32,0,1,true)
        --shockwave:add(swmx,swmy,16,0,1,true)
        ship=#enemy.ships
      end
      ship=ship+1
    end
    if hashit then
      table.remove(self.fires,i)
      i=i-1
    end
    i=i+1
  end
  --self:trimsound()
end