explosion=constructObject()

function explosion:load()
  self.frame={}
  local flist=love.filesystem.enumerate('/img/explosion/frames/')
  for i,file in ipairs(flist) do self.frame[i]=newPaddedImage('img/explosion/frames/'..file) end
  self.soundfile='/snd/explode.ogg'
end

function explosion:init()
  self.data={}
  self.w,self.h=self.frame[1].w,self.frame[1].h
end

function explosion:add(x,y,speed,direction) -- where x,y is midpoint of explosion
  if #self.sound<=10 then self:playsound() end
  table.insert(self.data,{x,y,speed,direction,1})
end

function explosion:draw()
  for i=1,#self.data do
    local x,y=math.floor(self.data[i][1]),math.floor(self.data[i][2])
    local ox,oy=math.floor(self.w/2),math.floor(self.h/2)
    local frame=self.frame[self.data[i][5]].image
    love.graphics.draw(frame,x,y,0,1,1,ox,oy)
  end
end

function explosion:update(dt)
  i=1
  while i<=#self.data do
    self.data[i][2]=self.data[i][2]+((self.data[i][3]*dt)*self.data[i][4])
    self.data[i][5]=self.data[i][5]+math.ceil(100*dt)
    if self.data[i][2]>love.graphics.getHeight() or self.data[i][5]>#self.frame then
      table.remove(self.data,i) i=i-1
    end
    i=i+1
  end
  self:trimsound()
end