playerlaser=constructObject()

function playerlaser:load()
  local fire=newPaddedImage('/img/weapons/player/laser.png')
  self.image=fire.image
  self.w,self.h=fire.w,fire.h
  self.soundfile='/snd/player/laser.ogg'
end

function playerlaser:init()
  self.fuse=0
  self.fuselen=5
  self.fusespeed=20
  self.speed=250
  self.fires={}
  self.dmg=1
end

function playerlaser:addfire(x,y)
  if self.fuse>0 then return end
  self:playsound()
  table.insert(self.fires,{x,y})
  table.insert(self.fires,{x+12,y})
  self.fuse=self.fuselen
end

function playerlaser:draw()
  love.graphics.setColor(255,255,255,128)
  for i=1,#self.fires do
    love.graphics.draw(self.image,math.floor(self.fires[i][1]),math.floor(self.fires[i][2]))
  end
  love.graphics.setColor(255,255,255,255)
end

function playerlaser:update(dt)
  i=1
  while i<=#self.fires do
    local x,y=self.fires[i][1],self.fires[i][2]
    y=y-(self.speed*dt)
    if y<(self.h*-1) then table.remove(self.fires,i)
    else self.fires[i]={x,y} i=i+1 end
  end
  if self.fuse>0 then
   self.fuse=self.fuse-((self.fusespeed+player.firerate)*dt)
   if self.fuse<0 then self.fuse=0 end
  end
  -- collision checking
  i=1
  while i<=#self.fires do
    local hashit=false
    local fl,fr=self.fires[i][1]+29,self.fires[i][1]+33 -- fire left & right
    local ft,fb=self.fires[i][2]+17,self.fires[i][2]+40 -- fire top & bottom
    local ship=1
    while ship<=#enemy.ships do
      local this=enemy.ships[ship]
      local sl,sr=this.x,this.x+this.w -- ship left & right
      local st,sb=this.y,this.y+this.h -- ship top & bottom
      if (fr>=sl and fl<=sr) and (ft<=sb and fb>=st) then
        local hx=fl+2
        if hx>sr then hx=sr end
        if hx<sl then hx=sl end
        local hy=(ft+fb)/2
        if hy<st then hy=st end
        if hy>sb then hy=sb end
        hit:add(hx,hy,this.speed,1)
        local isdead=enemy:applyDamage(ship,self.dmg,true)
        if isdead then ship=ship-1 end
        hashit=true
        ship=#enemy.ships
      end
      ship=ship+1
    end
    if hashit then
      table.remove(self.fires,i)
      i=i-1
    end
    i=i+1
  end
  self:trimsound()
end