shockwave=constructObject()

function shockwave:load()
  self.ring=newPaddedImage('/img/explosion/shockwave.png')
end

function shockwave:init()
  self.data={}
  self.forcedDamage=false
end

function shockwave:add(x,y,radius,speed,strength,creditplayer)
  table.insert(self.data,{x,y,1,radius*2,128,speed,strength,creditplayer,x,y})
end

function shockwave:draw()
  i=1
  while i<=#self.data do
    local this=self.data[i]
    local diameter=this[3]
    local scale=diameter/self.ring.w
    local alpha=this[5]
    local x,y=this[1],this[2]
    local offset=math.floor((diameter/self.ring.w)/2)
    love.graphics.setColor(128,0,0,alpha)
    love.graphics.draw(self.ring.image,x,y,0,scale,scale,offset,offset)
    i=i+1
  end
  love.graphics.setColor(255,255,255,255)
end

function shockwave:update(dt)
  i=1
  while i<=#self.data do
    -- radial expansion of shockwave
    self.data[i][3]=self.data[i][3]+(250*dt)
    self.data[i][1]=self.data[i][1]-(125*dt)
    self.data[i][2]=self.data[i][2]-(125*dt)
    -- end of radial expansion
    self.data[i][5]=self.data[i][5]-(250*dt) -- alpha
    self.data[i][2]=self.data[i][2]+(self.data[i][6]*dt) -- Y movement change
    j=1
    while j<=#enemy.ships do
      local precheck=#enemy.ships
      local ship=enemy.ships[j]
      local smx,smy=getMidpoint(ship.x,ship.y,ship.w,ship.h)
      local dist=getDistance(self.data[i][9],self.data[i][10],smx,smy)
      if dist<=self.data[i][3] then
        if self.forcedDamage then
          hit:add(smx,smy,ship.speed,1)
          enemy:applyDamage(j,self.data[i][7],self.data[i][8])
          self.forcedDamage=false
        elseif math.random(250)<=self.data[i][7] then
          hit:add(smx,smy,ship.speed,1)
          enemy:applyDamage(j,self.data[i][7],self.data[i][8])
        elseif math.random(250)<=self.data[i][7]*2 and math.floor(self.data[i][7]/2)>0 then
          hit:add(smx,smy,ship.speed,1)
          enemy:applyDamage(j,math.floor(self.data[i][7]/2),self.data[i][8])
        end
      end
      if #enemy.ships<precheck then j=0 end
      j=j+1
    end
    if self.data[i][5]<=32 then self.data[i][5]=64 end
    if self.data[i][2]>love.graphics.getHeight() or self.data[i][3]>self.data[i][4] then
      table.remove(self.data,i)
      i=i-1
    end
    i=i+1
  end
end