status=constructObject()

function status:load()
  self.killbar=newPaddedImage('/img/status/killbar.png')
  self.shieldbar=newPaddedImage('/img/status/shieldbar.png')
  self.shields={}
  for i=1,10 do self.shields[i]=newPaddedImage('/img/shields/'..i..'.png') end
  self.shieldend=newPaddedImage('/img/shields/end.png')
  self.oneupsnd=love.audio.newSource("/snd/1up.ogg","static")
end

function status:init()
  self.oneupcount=nil
  self.oneupblink=false
end

function status:drawScore()
  love.graphics.setFont(gamefont)
  local score=string.format("%d",player.score)
  love.graphics.print(score,(love.graphics.getWidth()/2)-(love.graphics.getFont():getWidth(score)/2),(10+player.h)/2)
end

function status:drawLives()
  love.graphics.setFont(gamefont)
  local desc=string.format("*%d",player.lives)
  local x=love.graphics.getWidth()-10-love.graphics.getFont():getWidth(desc)
  love.graphics.print(desc,x,(10+player.h)/2)
  love.graphics.draw(player.image,x-10-player.w,10)
end

function status:drawShieldbar()
  love.graphics.draw(self.shieldbar.image,10,love.graphics.getHeight()-self.shieldbar.h-10)
  local x,y=33,love.graphics.getHeight()-self.shieldbar.h-6
  for i=1,player.shields do
    love.graphics.draw(self.shields[i].image,x,y)
    x=x+self.shields[i].w
  end
  love.graphics.draw(self.shieldend.image,x,y)
end

function status:drawKillbar()
  local x,y=love.graphics.getWidth()-self.killbar.w-10,love.graphics.getHeight()-self.killbar.h-10
  love.graphics.draw(self.killbar.image,x,y)
  desc=string.format("%d",player.kills)
  love.graphics.printf(desc,x+28,y+6,42,"center")
end

function status:drawOneUp()
  -- 1-up notice
  if self.oneupcount~=nil and self.oneupblink==true then
    local mx,my=love.graphics.getWidth()/2,love.graphics.getHeight()/2
    love.graphics.draw(player.image,math.floor(mx-(player.w/2)),math.floor(my-(player.h/2)))
    local desc="1-UP!"
    love.graphics.print(desc,math.floor(mx-(love.graphics.getFont():getWidth(desc)/2)),math.floor(my-(love.graphics.getFont():getHeight()/2)))
  end
end

function status:draw()
  self:drawScore()
  self:drawLives()
  self:drawShieldbar()
  self:drawKillbar()
  self:drawOneUp()
  local desc=string.format("LVL: %d",player.level)
  love.graphics.print(desc,10,10)
end

function status:updateOneUp(dt)
  -- 1-up notice timer
  if self.oneupcount~=nil then
    self.oneupcount=self.oneupcount+(2*dt)
    if self.oneupcount>=1 then self.oneupblink=true self.oneupsnd:play() end
    if self.oneupcount>=2 then self.oneupblink=false end
    if self.oneupcount>=3 then self.oneupblink=true self.oneupsnd:play() end
    if self.oneupcount>=4 then self.oneupblink=false end
    if self.oneupcount>=5 then self.oneupblink=true self.oneupsnd:play() end
    if self.oneupcount>=6 then self.onupblink=false self.oneupcount=nil end
  end
end

function status:update(dt)
  self:updateOneUp(dt)
end